from logging import getLogger

import cv2
import numpy as np

from receipt_scanner.image.debug import debug_show
from receipt_scanner.image.filters.base_filter import Filter

logger = getLogger(__name__)


class DenoiseFilter(Filter):
    def __init__(self, debug: bool = False) -> None:
        self.debug = debug

    def eval(self, image: np.ndarray) -> np.ndarray:
        logger.debug("Applying 'DenoiseFilter'...")
        denoised_image = cv2.fastNlMeansDenoisingColored(image, None, 15, 15, 7, 21)
        debug_show(denoised_image, debug=self.debug)
        return denoised_image
